from numpy import *
import sys
import subprocess as sp
#Try to look for coregrowthdir
coregrowthdir = sp.Popen(['echo $COREGROWTHPATH'], stdout=sp.PIPE, shell=True).communicate()[0].strip()
sys.path.append(coregrowthdir+'/src/')
import globalvars80 as g
import rout80 as rout
from core80 import *
import cProfile
import pstats

#The parameters we want to probe
a0arr = [3.2, 4.5, 6.4, 9.05, 12.8, 18.1, 25.6, 36.2]
fsigarr = [1.0, 3.0, 10.0]
spiniarr = [1e5, 1e6, 1e7]

N1 = len(a0arr)
N2 = len(fsigarr)
N3 = len(spiniarr)
Mout_na = zeros((N1,N2))
Mout_at = zeros((N1,N2))

def doParstudy(fname):
  f=open(fname,'w')
  for i in range(N1):
    for j in range(N2):
      for k in range(N3):
        g.sPini = spiniarr[k]
       #print g.sPini/1e5, a0arr[i], fsigarr[j]
        g.Tend = 1e7*g.yr
        g.a0 = a0arr[i]*g.au
        g.fsig = fsigarr[j]
        g.doRD = True
        g.doFR = True
        g.doER = True
        g.doTD = False
        g.doTS = False
        g.Tend = 1e7*g.yr

        #models w/o AE
        g.doAE = False
        out = main()
        Mc = rout.readData(['Mc'], dtype='Float')
        Mout_na = max(Mc)/g.Mearth

        #models w/ AE
        g.doAE = True
        out = main()
       #cProfile.run("main()", 'shooterprof')
       #p = pstats.Stats('shooterprof')
       #p.strip_dirs().sort_stats('time').print_stats(5)
        Mc = rout.readData(['Mc'], dtype='Float')
        Mout_at = max(Mc) /g.Mearth
        #print "masses: ", Mout_na, Mout_at
        line = '%8.2f'%a0arr[i]+'%8.2f'%fsigarr[j]+'%9.1e'%spiniarr[k]+'%9.1e'%Mout_na+'%9.1e'%Mout_at
        f.write(line+'\n')


#runsims must be true to start the computations
runsims = True
fname='Data/table8.dat'

if runsims:
  doParstudy(fname)

print('|====================================================')
print('|')
print('| Now trying to plot data. This may or may not work  ')
print('| depending on your matplotlib availibility/settings ')
print('|')
print('|====================================================')
from pylab import *

data=loadtxt(fname)
a0arr=unique(data[:,0])
fsigarr=unique(data[:,1])
Nentr=len(data[:,0])
N1 = len(a0arr)
N2 = len(fsigarr)
Mout_na = zeros((N1,N2,N3))
Mout_at = zeros((N1,N2,N3))
for k in range(Nentr):
  i=where(data[k,0]==a0arr)[0]
  j=where(data[k,1]==fsigarr)[0]
  l=where(data[k,2]==spiniarr)[0]
  Mout_na[i,j,l]=data[k,3]
  Mout_at[i,j,l]=data[k,4]


fig = figure(figsize=(9,7))
fig.subplots_adjust(wspace=0, hspace=0, bottom=0.08, top=0.99, left=0.08, right=0.99)
ax1 = fig.add_subplot(331)
ax2 = fig.add_subplot(332)
ax3 = fig.add_subplot(333)
ax4 = fig.add_subplot(334)
ax5 = fig.add_subplot(335)
ax6 = fig.add_subplot(336)
ax7 = fig.add_subplot(337)
ax8 = fig.add_subplot(338)
ax9 = fig.add_subplot(339)

axs = [[ax1, ax2, ax3], [ax4, ax5, ax6], [ax7, ax8, ax9]]

for l in range(3):
  for i in range(3):
    ax=axs[i][l]
    ax.loglog(a0arr, Mout_na[:,i,l], 's', c='k', mfc='w')
    ax.loglog(a0arr, Mout_at[:,i,l], 'o', c='k', mfc='w')
    ax.text(18, 70, str(fsigarr[i])+'xMMSN')
    ax.text(18, 35, str(spiniarr[l]/1e5)+'km')
    Miso = zeros((N1))
    M0arr = zeros((N1))
    for k in range(N1):
      [sig]=array(rout.mmsn(['Sig_d'],a=a0arr[k],fsigd=g.fsigd,fsig=fsigarr[i])) 
      Miso[k] = rout.M_iso(a0arr[k]*g.au, sig, g.btwig, g.Mstar)
    ax.plot(a0arr, Miso/g.Mearth, '-', c='k')
    if l<>0:
      ax.set_yticklabels([])
    if i<>2:
      ax.set_xticklabels([])
    ax.set_xlim(3.1,40)
    ax.set_ylim(1.1e-2, 2e2)

ax4.set_ylabel('Embryo mass after $10^7$ yr [$M_\\oplus$]')
ax8.set_xlabel('Disk radius [AU]')

ax1.legend(['-AE', '+AE', '$M_\\mathrm{iso}$', 'Kobayashi+2011'], numpoints=1, loc=2)
fig.savefig('fig8.eps')
close()
